local OWNMATSTIP, SELLWITHMATS, CUSTOM = 1, 2, 3
EnchantBotFu = AceLibrary("AceAddon-2.0"):new("FuBarPlugin-2.0", "AceDB-2.0")
local tablet = AceLibrary("Tablet-2.0")

function EnchantBotFu:OnInitialize()
	self.title = ENCHANTBOT_MENU
	self.category = "Tradeskill"
	self.cannotDetachTooltip  = true
	self.tooltipHiddenWhenEmpty  = true
	self.cannotHideText = false
	self.cannotAttachToMinimap = true
	self.hasNoColor = true
	self.hasIcon = true
	self.OnMenuRequest = self:PrepareMenu()
	self:SetIcon("Interface\\AddOns\\EnchantBot\\on")
	self:RegisterDB("EnchantBotFuDB")
end

function EnchantBotFu:ToggleSilent()
	EnchantBot_Silent = not EnchantBot_Silent
	self:Update()
end

function EnchantBotFu:ToggleStartStop()
	EnchantBot_On = not EnchantBot_On
	self:Update()
end

function EnchantBotFu:ToggleABStartStop()
	EnchantBot_AB_Support = not EnchantBot_AB_Support
	self:Update()
end

function EnchantBotFu:GetMode()
	if EnchantBot_Mode == OWNMATSTIP then
		return ENCHANTBOT_SMODE_TIPS
	elseif EnchantBot_Mode == SELLWITHMATS then
		return ENCHANTBOT_SMODE_SELL
	elseif EnchantBot_Mode == CUSTOM then
		return ENCHANTBOT_SMODE_CUSTOM
	end
end

function EnchantBotFu:SetMode(v)
	if v == ENCHANTBOT_SMODE_TIPS then
		EnchantBot_Mode = OWNMATSTIP
	elseif v == ENCHANTBOT_SMODE_SELL then
		EnchantBot_Mode = SELLWITHMATS
	elseif v == ENCHANTBOT_SMODE_CUSTOM then
		EnchantBot_Mode = CUSTOM
	end
	self:Update()
end

function EnchantBotFu:PrepareMenu()
	local options = {
		type = 'group',
		args = {
			start = {
				type = "toggle",
				name = ENCHANTBOT_ENABLE,
				desc = ENCHANTBOTFU_ENABLE_DESC,
				get = function () return EnchantBot_On end,
				set = "ToggleStartStop",
				order = 100,
		        },
		        forcescan = {
				type = "execute",
				name = ENCHANTBOT_SCAN,
				desc = ENCHANTBOTFU_SCAN_DESC,
				func = function () EnchantBot_ForceScan() end,
				order = 200,
			},
			options = {
				type = "group",
				name = ENCHANTBOTFU_OPTION,
				desc = ENCHANTBOTFU_OPTION_DESC,
				order = 300,
				args = {
					mode = {
						type = "text",
						name = ENCHANTBOTFU_MODE,
						desc = ENCHANTBOTFU_MODE_DESC,
						get = "GetMode",
						set = "SetMode",
						order = 100,
						validate = {ENCHANTBOT_SMODE_TIPS,ENCHANTBOT_SMODE_SELL,ENCHANTBOT_SMODE_CUSTOM}
					},
					minrank = {
						type = "text",
						name = ENCHANTBOTFU_MINRANK,
						desc = ENCHANTBOTFU_MINRANK_DESC,
						get = function () return EnchantBot_GetMinRank() end,
						set = function (v) EnchantBot_SetMinRank(v, false) end,
						order = 200,
						validate = {"optimal","medium","easy","trivial"}
					},
				        limit = {
						type = "range",
						name = ENCHANTBOTFU_LIMIT,
						desc = ENCHANTBOTFU_LIMIT_DESC,
						max = 20,
						min = 0,
						step = 1,
						isPercent = false,
						get = function () return EnchantBot_Limit end,
						set = function (v) EnchantBot_Limit = v end,
						order = 300,
				        },
				        silent = {
						type = "toggle",
						name = ENCHANTBOTFU_SILENT,
						desc = ENCHANTBOTFU_SILENT_DESC,
						get = function () return EnchantBot_Silent end,
						set = "ToggleSilent",
						order = 400,
				        },
				        absupport = {
						type = "toggle",
						name = ENCHANTBOT_AB_ENABLE,
						desc = ENCHANTBOTFU_AB_ENABLE_DESC,
						get = function () return EnchantBot_AB_Support end,
						set = "ToggleABStartStop",
						order = 500,
				        }
				}
			}
		}
    	}
	return options
end

function EnchantBotFu:OnDataUpdate()
end

function EnchantBotFu:OnTextUpdate()
	if self:IsTextShown() then
		self:SetText(EnchantBot_GetButtonText())
	end
	if not self:IsIconShown() then
		self:HideIcon()
	else
		if EnchantBot_On then
			self:SetIcon("Interface\\AddOns\\EnchantBot\\on")
		else
			self:SetIcon("Interface\\AddOns\\EnchantBot\\off")
		end
	end
end

function EnchantBotFu:OnTooltipUpdate()
	local cat = tablet:AddCategory(
		'text', "",
		'columns', 1,
		'child_textR', 1,
		'child_textG', 1,
		'child_textB', 0
	)
	cat:AddLine(
		'text', EnchantBot_GetTooltipText()
	)
	tablet:SetHint(ENCHANTBOT_HINT)
end

function EnchantBotFu:OnClick()
	EnchantBot_ToggleOptions()
end
